#line 1 "F:/MikroC/ModbusSlave/ModbusSlave.c"
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for pic/include/built_in.h"
#line 1 "f:/mikroc/modbusslave/modbus.h"
#line 1 "f:/mikroc/modbusslave/types.h"
#line 14 "f:/mikroc/modbusslave/types.h"
 typedef unsigned long ulong;


 typedef unsigned int uint;


 typedef unsigned short ushort;


 typedef unsigned char byte;


 typedef enum ebool { FALSE, TRUE } boolean;
#line 63 "f:/mikroc/modbusslave/modbus.h"
 typedef enum eBaudRates {
 BAUD_1200 = 12,
 BAUD_2400 = 24,
 BAUD_4800 = 48,
 BAUD_9600 = 96,
 BAUD_19200 = 192,
 BAUD_38400 = 384,
 BAUD_57600 = 576,
 BAUD_115200 = 1152
 } baudRate;

 typedef enum eModbusTypes {
 INVALID_MB_TYPE = 0,
 COILS = 1,
 STATUS_INPUTS = 2,
 HOLDING_REGISTERS = 3,
 INPUT_REGISTERS = 4
 } mbType;

 typedef enum eModbusFunctions {
 READ_COILS = 1,
 READ_STATUS_INPUTS = 2,
 READ_HOLDING_REGISTERS = 3,
 READ_INPUT_REGISTERS = 4,
 FORCE_SINGLE_COIL = 5,
 PRESET_SINGLE_REGISTER = 6,
 FORCE_MULTIPLE_COILS = 15,
 PRESET_MULTIPLE_REGISTERS = 16
 } mbFunction;

 typedef enum eModbusExceptions {
 NO_EXCEPTION = 0,
 ILLEGAL_FUNCTION = 1,
 ILLEGAL_DATA_ADDRESS = 2,
 ILLEGAL_DATA_VALUE = 3,
 SLAVE_DEVICE_FAILURE = 4,
 ACKNOWLEDGE = 5,
 SLAVE_DEVICE_BUSY = 6,
 NEGATIVE_ACKNOWLEDGE = 7,
 MEMORY_PARITY_ERROR = 8
 } mbException;

 typedef struct _modbusBlock {

 byte bytSlaveAddress;

 mbType eType;

 uint uintAddress;

 uint uintTotal;

 void* paryData;

 boolean blnUpdate;




 void (*pCallback)(struct _modbusBlock* pBlock);


 struct _modbusBlock* pNext;
 } modbusBlockDef;

 boolean addModbusBlock(byte bytSlaveAddress,
 mbType eType,
 modbusBlockDef* pBlock,
 uint uintAddress,
 uint uintTotal,
 void* paryData,



 void (*pCallback)(struct _modbusBlock* pBlock)

 );
 uint calcCRC(void);
 void decodePacket(void);
 int modbusSerialInit(baudRate eBaud, const byte bytStopBits, ...);
 void restartRx(void);
 void serviceIOBlocks(void);
 void startTimeout(void);
#line 152 "f:/mikroc/modbusslave/modbus.h"
 extern modbusBlockDef* pHoldingRegs;
 extern modbusBlockDef* pStatusBits;
 extern modbusBlockDef* pInputRegs;
 extern modbusBlockDef* pCoils;

 extern mbException eMbExceptionCode;

 extern uint uintMbRxGapSetPt1;
 extern uint uintMbRxGapSetPt2;
 extern uint uintMbRxGapSetPt3;
 extern uint uintMbRxGapSetPt;

 extern uint uintPacketTimeout;

 extern uint uintCRC;

 extern uint uintMbRxGap;

 extern byte bytMbSlaveAddress;

 extern byte arybytMbBuffer[ 256 ];

 extern byte bytMbRxphase;
 extern byte bytMbIndex;

 extern sfr sbit Tx_dir;
#line 62 "F:/MikroC/ModbusSlave/ModbusSlave.c"
static modbusBlockDef* pCurrBlock;
#line 74 "F:/MikroC/ModbusSlave/ModbusSlave.c"
static boolean coilState(uint uintAddress, boolean blnState) {
 if ( pCurrBlock !=  ((void*)0)  ) {

 byte bytIndex, bytBit;
 uint uintOffset;
 uintOffset = uintAddress - pCurrBlock->uintAddress;
 bytIndex = uintOffset / 8;
 bytBit = 1 << (uintOffset % 8);

 if ( blnState == TRUE ) {

 ((byte*)pCurrBlock->paryData)[bytIndex] |= bytBit;
 } else {

 ((byte*)pCurrBlock->paryData)[bytIndex] &= (0xff ^ bytBit);
 }
 pCurrBlock->blnUpdate = TRUE;
 return TRUE;
 }
 return FALSE;
}
#line 108 "F:/MikroC/ModbusSlave/ModbusSlave.c"
static uint packBits(mbType eType, byte* pBuffer,
 uint uintStart, uint uintEnd) {

 modbusBlockDef* pNode;
 uint uintBytes = 0;

 if ( eType == COILS ) {
 pNode = pCoils;
 } else if( eType == STATUS_INPUTS ) {
 pNode = pStatusBits;
 } else {
 return 0;
 }
 while( pNode !=  ((void*)0)  ) {
 if ( uintStart >= pNode->uintAddress ) {
 break;
 }
 pNode = pNode->pNext;
 }
 if ( pNode !=  ((void*)0)  && uintEnd < pNode->uintAddress + pNode->uintTotal ) {
 uint uintOffset;
 byte bytIndex;

 uintOffset = uintStart - pNode->uintAddress;

 bytIndex = uintOffset / 8;

  ((char *)&uintOffset)[1]  = 1 << ( ((char *)&uintOffset)[0]  & 7);

  ((char *)&uintOffset)[0]  = 1;

 *pBuffer = 0;
 while( uintStart <= uintEnd ) {
 if (  ((char *)&uintOffset)[0] .B0 ) {
 uintBytes++;
 }

 if ( (((byte*)pNode->paryData)[bytIndex] &  ((char *)&uintOffset)[1] ) ) {
 *pBuffer |=  ((char *)&uintOffset)[0] ;
 }
  ((char *)&uintOffset)[1]  <<= 1;

 if (  ((char *)&uintOffset)[1]  == 0 ) {
  ((char *)&uintOffset)[1]  = 1;
 bytIndex++;
 }
  ((char *)&uintOffset)[0]  <<= 1;

 if (  ((char *)&uintOffset)[0]  == 0 ) {
  ((char *)&uintOffset)[0]  = 1;
 pBuffer++;
 *pBuffer = 0;
 }

 uintStart++;
 }
 }
 return uintBytes;
}
#line 180 "F:/MikroC/ModbusSlave/ModbusSlave.c"
static uint packRegisters(mbType eType, byte* pBuffer,
 uint uintStart, uint uintEnd) {

 modbusBlockDef* pNode;
 uint uintBytes = 0;

 if ( eType == HOLDING_REGISTERS ) {
 pNode = pHoldingRegs;
 } else if( eType == INPUT_REGISTERS ) {
 pNode = pInputRegs;
 } else {
 return 0;
 }
 while( pNode !=  ((void*)0)  ) {
 if ( uintStart >= pNode->uintAddress ) {
 break;
 }
 pNode = pNode->pNext;
 }
 if ( pNode !=  ((void*)0)  && uintEnd < (pNode->uintAddress + pNode->uintTotal) ) {
 uint uintOffset;
 uintOffset = uintStart - pNode->uintAddress;
 while( uintStart <= uintEnd ) {
 pBuffer[uintBytes++] =  ((char *)&((uint*)pNode->paryData)[uintOffset])[1] ;
 pBuffer[uintBytes++] =  ((char *)&((uint*)pNode->paryData)[uintOffset])[0] ;

 uintStart++;
 uintOffset++;
 }
 }
 return uintBytes;
}
#line 224 "F:/MikroC/ModbusSlave/ModbusSlave.c"
static boolean setRegister(uint uintAddress, byte bytDataHi, byte bytDataLo) {
 if ( pCurrBlock !=  ((void*)0)  ) {
 uint uintTemp, uintOffset;
  ((char *)&uintTemp)[0]  = bytDataLo;
  ((char *)&uintTemp)[1]  = bytDataHi;
 uintOffset = uintAddress - pCurrBlock->uintAddress;
 ((uint*)pCurrBlock->paryData)[uintOffset] = uintTemp;
 pCurrBlock->blnUpdate = TRUE;
 return TRUE;
 }
 return FALSE;
}
#pragma funcall decodePacket dummy
#line 248 "F:/MikroC/ModbusSlave/ModbusSlave.c"
void decodePacket(void) {
 if ( TMR0IF_bit ) {
 bytMbRxphase.B0 = 1;
 TMR0ON_bit = 0;

 TMR0IF_bit = 0;

 if ( bytMbRxphase.B7 ) {

 restartRx();
 return;
 }
 }
 if( RCIF_bit ) {
 byte bytTemp;

 if ( OERR_bit || FERR_bit ) {
 restartRx();
 return;
 }


 bytTemp = RCREG;


 if ( bytMbRxphase == 0 || bytMbRxphase.B2 == 1 ||
 bytMbIndex >=  256  ) {

 bytMbIndex = 0;
 bytMbRxphase = 0;
 startTimeout();
 return;
 }
 if ( bytMbIndex == 0) {

 bytMbRxphase = 2;
 }

 arybytMbBuffer[bytMbIndex++] = bytTemp;

 startTimeout();
 } else if ( bytMbRxphase.B7 ) {
 if ( TXIF_bit ) {
 if ( bytMbIndex < arybytMbBuffer[0] ) {
 TXREG = arybytMbBuffer[bytMbIndex++];
 } else {

 startTimeout();

 TXIE_bit = 0;
 }
 return;
 }
 }
 if ( bytMbRxphase == 3 ) {

 bytMbRxphase = 4;
 startTimeout();
 }
 if ( bytMbRxphase != 5 ) {

 return;
 }
 if ( bytMbSlaveAddress == arybytMbBuffer[0] && bytMbIndex > 3 ) {

 pCurrBlock =  ((void*)0) ;

 bytMbIndex -= 2;
 uintCRC = calcCRC();

 if (  ((char *)&uintCRC)[0]  == arybytMbBuffer[bytMbIndex] &&
  ((char *)&uintCRC)[1]  == arybytMbBuffer[bytMbIndex + 1] ) {

 bytMbIndex = 3;

 switch( arybytMbBuffer[1] ) {
 case READ_COILS:
 case FORCE_SINGLE_COIL:
 case FORCE_MULTIPLE_COILS:
 if ( pCoils ==  ((void*)0)  ) {

 eMbExceptionCode = ILLEGAL_DATA_ADDRESS;
 } else {
 pCurrBlock = pCoils;
 }
 break;
 case READ_STATUS_INPUTS:
 if ( pStatusBits ==  ((void*)0)  ) {

 eMbExceptionCode = ILLEGAL_DATA_ADDRESS;
 } else {
 pCurrBlock = pStatusBits;
 }
 break;
 case READ_HOLDING_REGISTERS:
 case PRESET_SINGLE_REGISTER:
 case PRESET_MULTIPLE_REGISTERS:
 if ( pHoldingRegs ==  ((void*)0)  ) {

 eMbExceptionCode = ILLEGAL_DATA_ADDRESS;
 } else {
 pCurrBlock = pHoldingRegs;
 }
 break;
 case READ_INPUT_REGISTERS:
 if ( pInputRegs ==  ((void*)0)  ) {

 eMbExceptionCode = ILLEGAL_DATA_ADDRESS;
 } else {
 pCurrBlock = pInputRegs;
 }
 break;
 default:

 eMbExceptionCode = ILLEGAL_FUNCTION;
 break;
 }
 if( eMbExceptionCode == NO_EXCEPTION ) {
 uint uintSAddr, uintEAddr, uintItemCount;
 uint uintOffset, uintAddr;
 boolean blnState;
 mbType eType;
 byte bytBit;

  ((char *)&uintSAddr)[0]  = arybytMbBuffer[3];
  ((char *)&uintSAddr)[1]  = arybytMbBuffer[2];

 if ( arybytMbBuffer[1] == FORCE_SINGLE_COIL
 || arybytMbBuffer[1] == PRESET_SINGLE_REGISTER ) {
 uintItemCount = 1;
 } else {

  ((char *)&uintItemCount)[0]  = arybytMbBuffer[5];
  ((char *)&uintItemCount)[1]  = arybytMbBuffer[4];
 }

 uintEAddr = uintSAddr + uintItemCount;
 uintSAddr++;

 while( pCurrBlock !=  ((void*)0)  ) {
 if ( uintSAddr >= pCurrBlock->uintAddress
 && uintEAddr <= (pCurrBlock->uintAddress +
 pCurrBlock->uintTotal - 1) ) {
 break;
 }
 pCurrBlock = pCurrBlock->pNext;
 }

 switch( arybytMbBuffer[1] ) {
 case READ_COILS:
 case READ_STATUS_INPUTS:
 if ( arybytMbBuffer[1] == READ_COILS ) {
 eType = COILS;
 } else {
 eType = STATUS_INPUTS;
 }
 arybytMbBuffer[2] = packBits(eType, &arybytMbBuffer[3],
 uintSAddr, uintEAddr);

 if ( arybytMbBuffer[2] == 0 ) {

 eMbExceptionCode = ILLEGAL_DATA_ADDRESS;
 } else {
 bytMbIndex += arybytMbBuffer[2];
 }
 break;
 case READ_HOLDING_REGISTERS:
 case READ_INPUT_REGISTERS:
 if ( arybytMbBuffer[1] == READ_INPUT_REGISTERS ) {
 eType = INPUT_REGISTERS;
 } else {
 eType = HOLDING_REGISTERS;
 }
 arybytMbBuffer[2] = packRegisters(eType, &arybytMbBuffer[3],
 uintSAddr, uintEAddr);
 if ( arybytMbBuffer[2] == 0 ) {

 eMbExceptionCode = ILLEGAL_DATA_ADDRESS;
 } else {
 bytMbIndex += arybytMbBuffer[2];
 }
 break;
 case FORCE_SINGLE_COIL:
 if ( arybytMbBuffer[4] == 0xff && arybytMbBuffer[5] == 0x0 ) {

 blnState = coilState(uintSAddr, TRUE);
 } else if ( arybytMbBuffer[4] == 0x0 && arybytMbBuffer[5] == 0x0 ) {

 blnState = coilState(uintSAddr, FALSE);
 }
 if ( blnState == FALSE ) {

 eMbExceptionCode = ILLEGAL_DATA_ADDRESS;
 } else {
 bytMbIndex += 4;
 }
 break;
 case PRESET_SINGLE_REGISTER:
 if ( setRegister(uintSAddr, arybytMbBuffer[4],
 arybytMbBuffer[5]) == FALSE ) {

 eMbExceptionCode = ILLEGAL_DATA_ADDRESS;
 } else {
 bytMbIndex += 4;
 }
 break;
 case FORCE_MULTIPLE_COILS:
 if ( uintItemCount >  1968  ||
 uintItemCount > (arybytMbBuffer[6] * 8) ) {

 eMbExceptionCode = ILLEGAL_DATA_ADDRESS;
 break;
 }
 case PRESET_MULTIPLE_REGISTERS:
 if ( (arybytMbBuffer[1] == PRESET_MULTIPLE_REGISTERS &&
 uintItemCount >  123 ) ) {

 eMbExceptionCode = ILLEGAL_DATA_ADDRESS;
 } else {
 bytBit = 1;
 uintOffset = 0;
 uintAddr = uintSAddr;

 while( uintAddr <= uintEAddr ) {
 if ( arybytMbBuffer[1] == PRESET_MULTIPLE_REGISTERS ) {
 if ( setRegister(uintAddr,
 arybytMbBuffer[7 + uintOffset],
 arybytMbBuffer[8 + uintOffset]) == FALSE ) {
 eMbExceptionCode = ILLEGAL_DATA_ADDRESS;
 break;
 }
 uintOffset += 2;
 uintAddr++;
 } else {
 blnState = FALSE;
 if ( (arybytMbBuffer[7 + uintOffset] & bytBit) > 0 ) {
 blnState = TRUE;
 }
 if ( coilState(uintAddr, blnState) == FALSE ) {
 eMbExceptionCode = ILLEGAL_DATA_ADDRESS;
 break;
 }
 bytBit <<= 1;
 if ( bytBit == 0 ) {
 bytBit = 1;
 uintOffset++;
 }
 uintAddr++;
 }
 }
 if ( eMbExceptionCode == NO_EXCEPTION ) {
 bytMbIndex += 3;
 }
 }
 break;
 }
 }
 if( eMbExceptionCode != NO_EXCEPTION ) {
 arybytMbBuffer[1] |=  0x80 ;
 arybytMbBuffer[2] = (byte)eMbExceptionCode;
 eMbExceptionCode = NO_EXCEPTION;
 }
 if ( bytMbIndex > 0 ) {

 uintCRC = calcCRC();
 arybytMbBuffer[bytMbIndex++] =  ((char *)&uintCRC)[0] ;
 arybytMbBuffer[bytMbIndex++] =  ((char *)&uintCRC)[1] ;

 while( bytMbRxphase.B0 == 0 ) ;

 CREN_bit = 0;
 RCIE_bit = 0;

 TXEN_bit = 1;
 Tx_dir = 1;

 bytMbRxphase = 128;

 TXREG = arybytMbBuffer[0];

 arybytMbBuffer[0] = bytMbIndex;

 while( !TXIF_bit ){}
 TXREG = arybytMbBuffer[1];

 bytMbIndex = 2;
 TXIE_bit = 1;
 return;
 }
 }
 }

 bytMbIndex = 0;
 bytMbRxphase = 1;
}
