#line 1 "F:/MikroC/ModbusSlave/main.c"
#line 1 "f:/mikroc/modbusslave/modbus.h"
#line 1 "f:/mikroc/modbusslave/types.h"
#line 14 "f:/mikroc/modbusslave/types.h"
 typedef unsigned long ulong;


 typedef unsigned int uint;


 typedef unsigned short ushort;


 typedef unsigned char byte;


 typedef enum ebool { FALSE, TRUE } boolean;
#line 63 "f:/mikroc/modbusslave/modbus.h"
 typedef enum eBaudRates {
 BAUD_1200 = 12,
 BAUD_2400 = 24,
 BAUD_4800 = 48,
 BAUD_9600 = 96,
 BAUD_19200 = 192,
 BAUD_38400 = 384,
 BAUD_57600 = 576,
 BAUD_115200 = 1152
 } baudRate;

 typedef enum eModbusTypes {
 INVALID_MB_TYPE = 0,
 COILS = 1,
 STATUS_INPUTS = 2,
 HOLDING_REGISTERS = 3,
 INPUT_REGISTERS = 4
 } mbType;

 typedef enum eModbusFunctions {
 READ_COILS = 1,
 READ_STATUS_INPUTS = 2,
 READ_HOLDING_REGISTERS = 3,
 READ_INPUT_REGISTERS = 4,
 FORCE_SINGLE_COIL = 5,
 PRESET_SINGLE_REGISTER = 6,
 FORCE_MULTIPLE_COILS = 15,
 PRESET_MULTIPLE_REGISTERS = 16
 } mbFunction;

 typedef enum eModbusExceptions {
 NO_EXCEPTION = 0,
 ILLEGAL_FUNCTION = 1,
 ILLEGAL_DATA_ADDRESS = 2,
 ILLEGAL_DATA_VALUE = 3,
 SLAVE_DEVICE_FAILURE = 4,
 ACKNOWLEDGE = 5,
 SLAVE_DEVICE_BUSY = 6,
 NEGATIVE_ACKNOWLEDGE = 7,
 MEMORY_PARITY_ERROR = 8
 } mbException;

 typedef struct _modbusBlock {

 byte bytSlaveAddress;

 mbType eType;

 uint uintAddress;

 uint uintTotal;

 void* paryData;

 boolean blnUpdate;




 void (*pCallback)(struct _modbusBlock* pBlock);


 struct _modbusBlock* pNext;
 } modbusBlockDef;

 boolean addModbusBlock(byte bytSlaveAddress,
 mbType eType,
 modbusBlockDef* pBlock,
 uint uintAddress,
 uint uintTotal,
 void* paryData,



 void (*pCallback)(struct _modbusBlock* pBlock)

 );
 uint calcCRC(void);
 void decodePacket(void);
 int modbusSerialInit(baudRate eBaud, const byte bytStopBits, ...);
 void restartRx(void);
 void serviceIOBlocks(void);
 void startTimeout(void);
#line 152 "f:/mikroc/modbusslave/modbus.h"
 extern modbusBlockDef* pHoldingRegs;
 extern modbusBlockDef* pStatusBits;
 extern modbusBlockDef* pInputRegs;
 extern modbusBlockDef* pCoils;

 extern mbException eMbExceptionCode;

 extern uint uintMbRxGapSetPt1;
 extern uint uintMbRxGapSetPt2;
 extern uint uintMbRxGapSetPt3;
 extern uint uintMbRxGapSetPt;

 extern uint uintPacketTimeout;

 extern uint uintCRC;

 extern uint uintMbRxGap;

 extern byte bytMbSlaveAddress;

 extern byte arybytMbBuffer[ 256 ];

 extern byte bytMbRxphase;
 extern byte bytMbIndex;

 extern sfr sbit Tx_dir;
#line 25 "F:/MikroC/ModbusSlave/main.c"
static volatile modbusBlockDef coilsBlock,
 statusBitsBlock,
 inputRegsBlock,
 holdingRegsBlock;
static volatile uint aryuintInputRegs[1], aryuintHoldingRegs[1];
static volatile byte arybytCoils[1], arybytStatusBits[1];
#line 34 "F:/MikroC/ModbusSlave/main.c"
void interrupt() {
 decodePacket();
}
#line 41 "F:/MikroC/ModbusSlave/main.c"
void coilsCallback(modbusBlockDef* pBlock) {


 LATB = ((byte*)pBlock->paryData)[0];
}
void holdingRegCallback(modbusBlockDef* pBlock) {


 LATA = ((uint*)pBlock->paryData)[0];
}
#line 54 "F:/MikroC/ModbusSlave/main.c"
void main() {

 ANSELA = 0x02;
 ANSELB = 0;
 ANSELC = 0;
 ANSELE = 0;


 TRISA = 0x02;
 TRISB = 0;
 TRISC = 0;
 TRISE = 0;

 TRISD = 0xff;

 LATB = 0;
 LATC = 0;
 LATE = 0;

 modbusSerialInit(BAUD_115200, 1, 1);

 memset(arybytCoils, 0, sizeof(arybytCoils));
 memset(arybytStatusBits, 0, sizeof(arybytStatusBits));
 memset(aryuintHoldingRegs, 0, sizeof(aryuintHoldingRegs));
 memset(aryuintInputRegs, 0, sizeof(aryuintInputRegs));

 addModbusBlock(1, COILS, &coilsBlock, 1, 8,
 (void*)arybytCoils, coilsCallback);
 addModbusBlock(1, STATUS_INPUTS, &statusBitsBlock, 1, 8,
 (void*)arybytStatusBits,  ((void*)0) );
 addModbusBlock(1, HOLDING_REGISTERS, &holdingRegsBlock, 1, 1,
 (void*)aryuintHoldingRegs, holdingRegCallback);
 addModbusBlock(1, INPUT_REGISTERS, &inputRegsBlock, 1, 1,
 (void*)aryuintInputRegs,  ((void*)0) );

 while (1) {

 arybytStatusBits[0] = PORTB;

 aryuintInputRegs[0] = ADC_Read(1);

 serviceIOBlocks();
 }
}
