#line 1 "F:/MikroC/ModbusSlave/modbus.c"
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for pic/include/stdarg.h"





typedef void * va_list[1];
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for pic/include/built_in.h"
#line 1 "f:/mikroc/modbusslave/modbus.h"
#line 1 "f:/mikroc/modbusslave/types.h"
#line 14 "f:/mikroc/modbusslave/types.h"
 typedef unsigned long ulong;


 typedef unsigned int uint;


 typedef unsigned short ushort;


 typedef unsigned char byte;


 typedef enum ebool { FALSE, TRUE } boolean;
#line 63 "f:/mikroc/modbusslave/modbus.h"
 typedef enum eBaudRates {
 BAUD_1200 = 12,
 BAUD_2400 = 24,
 BAUD_4800 = 48,
 BAUD_9600 = 96,
 BAUD_19200 = 192,
 BAUD_38400 = 384,
 BAUD_57600 = 576,
 BAUD_115200 = 1152
 } baudRate;

 typedef enum eModbusTypes {
 INVALID_MB_TYPE = 0,
 COILS = 1,
 STATUS_INPUTS = 2,
 HOLDING_REGISTERS = 3,
 INPUT_REGISTERS = 4
 } mbType;

 typedef enum eModbusFunctions {
 READ_COILS = 1,
 READ_STATUS_INPUTS = 2,
 READ_HOLDING_REGISTERS = 3,
 READ_INPUT_REGISTERS = 4,
 FORCE_SINGLE_COIL = 5,
 PRESET_SINGLE_REGISTER = 6,
 FORCE_MULTIPLE_COILS = 15,
 PRESET_MULTIPLE_REGISTERS = 16
 } mbFunction;

 typedef enum eModbusExceptions {
 NO_EXCEPTION = 0,
 ILLEGAL_FUNCTION = 1,
 ILLEGAL_DATA_ADDRESS = 2,
 ILLEGAL_DATA_VALUE = 3,
 SLAVE_DEVICE_FAILURE = 4,
 ACKNOWLEDGE = 5,
 SLAVE_DEVICE_BUSY = 6,
 NEGATIVE_ACKNOWLEDGE = 7,
 MEMORY_PARITY_ERROR = 8
 } mbException;

 typedef struct _modbusBlock {

 byte bytSlaveAddress;

 mbType eType;

 uint uintAddress;

 uint uintTotal;

 void* paryData;

 boolean blnUpdate;




 void (*pCallback)(struct _modbusBlock* pBlock);


 struct _modbusBlock* pNext;
 } modbusBlockDef;

 boolean addModbusBlock(byte bytSlaveAddress,
 mbType eType,
 modbusBlockDef* pBlock,
 uint uintAddress,
 uint uintTotal,
 void* paryData,



 void (*pCallback)(struct _modbusBlock* pBlock)

 );
 uint calcCRC(void);
 void decodePacket(void);
 int modbusSerialInit(baudRate eBaud, const byte bytStopBits, ...);
 void restartRx(void);
 void serviceIOBlocks(void);
 void startTimeout(void);
#line 152 "f:/mikroc/modbusslave/modbus.h"
 extern modbusBlockDef* pHoldingRegs;
 extern modbusBlockDef* pStatusBits;
 extern modbusBlockDef* pInputRegs;
 extern modbusBlockDef* pCoils;

 extern mbException eMbExceptionCode;

 extern uint uintMbRxGapSetPt1;
 extern uint uintMbRxGapSetPt2;
 extern uint uintMbRxGapSetPt3;
 extern uint uintMbRxGapSetPt;

 extern uint uintPacketTimeout;

 extern uint uintCRC;

 extern uint uintMbRxGap;

 extern byte bytMbSlaveAddress;

 extern byte arybytMbBuffer[ 256 ];

 extern byte bytMbRxphase;
 extern byte bytMbIndex;

 extern sfr sbit Tx_dir;
#line 25 "F:/MikroC/ModbusSlave/modbus.c"
modbusBlockDef* pCoils =  ((void*)0) ;
modbusBlockDef* pStatusBits =  ((void*)0) ;
modbusBlockDef* pHoldingRegs =  ((void*)0) ;
modbusBlockDef* pInputRegs =  ((void*)0) ;
#line 34 "F:/MikroC/ModbusSlave/modbus.c"
mbException eMbExceptionCode;

uint uintMbRxGapSetPt1;
uint uintMbRxGapSetPt2;
uint uintMbRxGapSetPt3;
uint uintMbRxGapSetPt;

uint uintPacketTimeout;

uint uintCRC;

uint uintMbRxGap;

byte bytMbSlaveAddress = 0;

byte arybytMbBuffer[ 256 ];

byte bytMbIndex = 0;
byte bytMbRxphase;

sbit Tx_dir at LATE.B0;
#line 73 "F:/MikroC/ModbusSlave/modbus.c"
boolean addModbusBlock(byte bytSlaveAddress,
 mbType eType,
 modbusBlockDef* pBlock,
 uint uintAddress,
 uint uintTotal,
 void* paryData,



 void (*pCallback)(struct _modbusBlock* pBlock)

 ) {
 modbusBlockDef** pLL;

 if ( bytSlaveAddress < 1 || bytSlaveAddress > 247 ) {
 return FALSE;
 }

 if ( pBlock ==  ((void*)0) 
 || uintAddress == 0
 || uintTotal == 0
 || paryData ==  ((void*)0)  ) {
 return FALSE;
 }
 if ( eType == COILS ) {
 pLL = &pCoils;
 } else if ( eType == STATUS_INPUTS ) {
 pLL = &pStatusBits;
 } else if ( eType == HOLDING_REGISTERS ) {
 pLL = &pHoldingRegs;
 } else if ( eType == INPUT_REGISTERS ) {
 pLL = &pInputRegs;
 } else {
 return FALSE;
 }
 if ( *pLL ==  ((void*)0)  ) {

 *pLL = pBlock;
 } else {

 modbusBlockDef* pNode;
 for( pNode=*pLL; pNode->pNext!= ((void*)0) ; pNode=pNode->pNext ) {
 if ( uintAddress >= pNode->uintAddress
 && uintAddress <= (pNode->uintAddress + pNode->uintTotal - 1) ) {

 return FALSE;
 }
 }

 pNode->pNext = pBlock;
 }

 pBlock->bytSlaveAddress = bytSlaveAddress;
 pBlock->eType = eType;
 pBlock->uintAddress = uintAddress;
 pBlock->uintTotal = uintTotal;
 pBlock->paryData = paryData;
 pBlock->pCallback = pCallback;
 pBlock->pNext =  ((void*)0) ;
}
#pragma funcall calcCRC dummy
#line 148 "F:/MikroC/ModbusSlave/modbus.c"
uint calcCRC(void) {
 asm {
 MBgetCRC:
 movff _bytMbIndex, R2
 lfsr 0, _arybytMbBuffer
 setf R0
 setf R1
 MBgetCRC1:
 movf POSTINC0,W
 xorwf R0,F
 movlw 8
 movwf R3
 MBgetCRC2:
 bcf STATUS,C
 rrcf R1,F
 rrcf R0,F
 bnc $+10
 movlw 0xA0
 xorwf R1,F
 movlw 0x01
 xorwf R0,F
 decfsz R3,F
 bra MBgetCRC2
 decfsz R2,F
 bra MBgetCRC1
 return
 }
 return 0;
}
#line 189 "F:/MikroC/ModbusSlave/modbus.c"
int modbusSerialInit(baudRate eBaud, const byte bytStopBits, ...) {
 long lngTimeoutPreset;
 byte bytTemp;
 va_list ap;

 ANSELC = 0;

  *ap = (char *)&bytStopBits + sizeof bytStopBits ;

 bytMbSlaveAddress =  (*(*(byte **)ap)++) ;

 memset(arybytMbBuffer, 0, sizeof(arybytMbBuffer));

 uintMbRxGap = 0;

 eMbExceptionCode = NO_EXCEPTION;

 switch( eBaud ) {
 case BAUD_1200:
 UART1_Init(BAUD_1200 * 100);
 lngTimeoutPreset =  (long)( 2 *110*Clock_kHz()/(4*BAUD_1200)) ;
 uintPacketTimeout =  2750 ;
 break;
 case BAUD_2400:
 UART1_Init(BAUD_2400 * 100);
 lngTimeoutPreset =  (long)( 2 *110*Clock_kHz()/(4*BAUD_2400)) ;
 uintPacketTimeout =  1375 ;
 break;
 case BAUD_4800:
 UART1_Init(BAUD_4800 * 100);
 lngTimeoutPreset =  (long)( 2 *110*Clock_kHz()/(4*BAUD_4800)) ;
 uintPacketTimeout =  688 ;
 break;
 case BAUD_9600:
 UART1_Init(BAUD_9600 * 100);
 lngTimeoutPreset =  (long)( 2 *110*Clock_kHz()/(4*BAUD_9600)) ;
 uintPacketTimeout =  344 ;
 break;
 case BAUD_19200:
 UART1_Init(BAUD_19200 * 100);
 lngTimeoutPreset =  (long)( 2 *110*Clock_kHz()/(4*BAUD_19200)) ;
 uintPacketTimeout =  172 ;
 break;
 case BAUD_38400:
 UART1_Init(BAUD_38400 * 100);
 lngTimeoutPreset =  (long)( 2 *110*Clock_kHz()/(4*BAUD_38400)) ;
 uintPacketTimeout =  86 ;
 break;
 case BAUD_57600:
 UART1_Init(BAUD_57600 * 100);
 lngTimeoutPreset =  (long)( 2 *110*Clock_kHz()/(4*BAUD_57600)) ;
 uintPacketTimeout =  57 ;
 break;
 case BAUD_115200:
 UART1_Init(BAUD_115200 * 100);
 lngTimeoutPreset =  (long)( 2 *110*Clock_kHz()/(4*BAUD_115200)) ;
 uintPacketTimeout =  29 ;
 break;
 default:
 return -1;
 }

 Delay_ms(100);



 T0CON.TMR0ON = 0;
 T0CON.T08BIT = 0;
 T0CON.T0CS = 0;
 T0CON.T0SE = 0;
 T0CON.PSA = 1;
 T0CON.T0PS2 = 0;
 T0CON.T0PS1 = 0;
 T0CON.T0PS0 = 0;

 bytTemp = 0;
 while( lngTimeoutPreset > 29126 ) {
 lngTimeoutPreset >>= 1;
 bytTemp++;
 }
 if ( bytTemp > 0 && bytTemp <= 8 ) {
 T0CON.PSA = 0;
 T0CON = T0CON | (--bytTemp & 0x07);
 }
 uintMbRxGapSetPt1 = (uint)-(lngTimeoutPreset >> 1);
 uintMbRxGapSetPt2 = (uint)-lngTimeoutPreset;
 uintMbRxGapSetPt3 = (uint)-(lngTimeoutPreset*5 >> 2);
 uintMbRxGapSetPt = (uint)-(lngTimeoutPreset*9 >> 2);

 if ( bytStopBits != 1 ) {
 TX9_bit = 1;
 TX9D_bit = 1;
 }


 restartRx();
 TMR0IE_bit = 1;

 PEIE_bit = 1;

 GIE_bit = 1;
}
#line 301 "F:/MikroC/ModbusSlave/modbus.c"
void restartRx(void) {

 bytMbRxphase = RCREG;
 bytMbRxphase = RCREG;

 CREN_bit = 0;
 CREN_bit = 1;

 Tx_dir = 0;





 bytMbRxphase = 0;
 bytMbIndex = 0;

 TXEN_bit = 0;
 TXIE_bit = 0;

 RCIE_bit = 1;
 startTimeout();
}
#line 334 "F:/MikroC/ModbusSlave/modbus.c"
static void serviceIOBlocksPrimitive(modbusBlockDef* pBlockType) {
 modbusBlockDef* pNode;
 for( pNode=pBlockType; pNode!= ((void*)0) ; pNode=pNode->pNext ) {
 if ( pNode->blnUpdate == TRUE ) {
 if ( pNode->pCallback !=  ((void*)0)  ) {
 (*pNode->pCallback)(pNode);
 }
 pNode->blnUpdate = FALSE;
 }
 }
}
#line 355 "F:/MikroC/ModbusSlave/modbus.c"
void serviceIOBlocks(void) {
 if ( pHoldingRegs !=  ((void*)0)  ) {
 serviceIOBlocksPrimitive(pHoldingRegs);
 }
 if ( pStatusBits !=  ((void*)0)  ) {
 serviceIOBlocksPrimitive(pStatusBits);
 }
 if ( pInputRegs !=  ((void*)0)  ) {
 serviceIOBlocksPrimitive(pInputRegs);
 }
 if ( pCoils !=  ((void*)0)  ) {
 serviceIOBlocksPrimitive(pCoils);
 }
}
#line 379 "F:/MikroC/ModbusSlave/modbus.c"
void startTimeout(void) {

 TMR0ON_bit = 0;

 if ( bytMbRxphase.B1 ) {
 TMR0H =  ((char *)&uintMbRxGapSetPt3)[1] ;
 TMR0L =  ((char *)&uintMbRxGapSetPt3)[0] ;
 } else if ( bytMbRxphase.B2 ) {
 TMR0H =  ((char *)&uintMbRxGapSetPt2)[1] ;
 TMR0L =  ((char *)&uintMbRxGapSetPt2)[0] ;
 } else if ( bytMbRxphase.B7 ) {
 TMR0H =  ((char *)&uintMbRxGapSetPt1)[1] ;
 TMR0L =  ((char *)&uintMbRxGapSetPt1)[0] ;
 } else {
 TMR0H =  ((char *)&uintMbRxGapSetPt)[1] ;
 TMR0L =  ((char *)&uintMbRxGapSetPt)[0] ;
 }

 TMR0IF_bit = 0;

 TMR0ON_bit = 1;
}
